/*see 
http://www.conwaylife.com/wiki/Cellular_automaton#Rules
for rules on cellular automation*/

cell[][] grid;
int boxSize;
int borderSize;
boolean wrap;
int gridHeight;
button[] buttons;
boolean playing;
Boolean mousePressedS;
Boolean mousePressedPrev;
int speed;
int time;
Boolean[] survival;
Boolean[] born;
void setup() {
  playing=false;
  boxSize = 10;
  borderSize = 0;
  survival=new Boolean[] {false,false,true,true,false,false,false,false,false};
  born=new Boolean[] {false,false,false,true,false,false,false,false,false};
  int gridSizeX = 100;
  int gridSizeY = 60;
  speed=4;
  time=0;
  wrap=true;
  grid=new cell[gridSizeX][gridSizeY];
  createCells(gridSizeX,gridSizeY);
  gridHeight=(boxSize+borderSize)*getGridSizeY()+borderSize+1;
  mousePressedS=false;
  mousePressedPrev=false;
  buttons=new button[25];
  buttons[0]=new button(10,gridHeight+10,140,50,"Play");
  buttons[1]=new button(160,gridHeight+10,140,50,"Step");
  buttons[2]=new button(310,gridHeight+10,140,50,"Reset");
  buttons[3]=new button(460,gridHeight+10,140,50,"Wrapping is on");
  buttons[4]=new button(610,gridHeight+10,89,50,"Speed: 1/"+speed);
  buttons[5]=new button(701,gridHeight+10,49,24,"up");
  buttons[6]=new button(701,gridHeight+35,49,24,"down");
  
  buttons[7]=new button(760,gridHeight+10,16,16,"0");
  buttons[8]=new button(777,gridHeight+10,16,16,"1");
  buttons[9]=new button(794,gridHeight+10,16,16,"2");
  buttons[10]=new button(760,gridHeight+27,16,16,"3");
  buttons[11]=new button(777,gridHeight+27,16,16,"4");
  buttons[12]=new button(794,gridHeight+27,16,16,"5");
  buttons[13]=new button(760,gridHeight+44,16,16,"6");
  buttons[14]=new button(777,gridHeight+44,16,16,"7");
  buttons[15]=new button(794,gridHeight+44,16,16,"8");
  
  buttons[16]=new button(760+60,gridHeight+10,16,16,"0");
  buttons[17]=new button(777+60,gridHeight+10,16,16,"1");
  buttons[18]=new button(794+60,gridHeight+10,16,16,"2");
  buttons[19]=new button(760+60,gridHeight+27,16,16,"3");
  buttons[20]=new button(777+60,gridHeight+27,16,16,"4");
  buttons[21]=new button(794+60,gridHeight+27,16,16,"5");
  buttons[22]=new button(760+60,gridHeight+44,16,16,"6");
  buttons[23]=new button(777+60,gridHeight+44,16,16,"7");
  buttons[24]=new button(794+60,gridHeight+44,16,16,"8");
  
  buttons[9].changeColor(color(0,0,255));
  buttons[9].setSelected(true);
  buttons[10].changeColor(color(0,0,255));
  buttons[10].setSelected(true);
  
  buttons[19].changeColor(color(0,0,255));
  buttons[19].setSelected(true);
  
  size((boxSize+borderSize)*getGridSizeX()+borderSize+1,gridHeight+70);
}
void createCells(int gridSizeX,int gridSizeY){
  for(int x = 0; x < gridSizeX; x++) {
    for(int y = 0; y < gridSizeY; y++) {
      grid[x][y]=new cell(x,y);
    }
  }
}
void update1(Boolean run){
  if(run){
    for(int x = 0; x < getGridSizeX(); x++) {
      for(int y = 0; y < getGridSizeY(); y++) {
        grid[x][y].update();
      }
    }
  }
}
void draw(){
  background(100);
  mousePressedS=(mousePressed&&!mousePressedPrev);
  time=(time+1)%speed;
  update1(playing&&time==0);
  if(mousePressed&&mouseY<gridHeight){
    try{grid[floor(mouseX/(boxSize+borderSize))][floor(mouseY/(boxSize+borderSize))].pressed();}catch(ArrayIndexOutOfBoundsException e){}
  }
  for(int x = 0; x < getGridSizeX(); x++) {
    for(int y = 0; y < getGridSizeY(); y++) {
      grid[x][y].update2();
    }
  }
  textSize(14);
  int buttonClicked=-1;
  for(int i=0; i<buttons.length; i++){
    if(buttons[i].update(mousePressedS)){
      buttonClicked=i;
    }
  }
  switch(buttonClicked){
    case -1: break;
    case 0: if(!playing){playing=true; time=0; buttons[0].change("Pause");}else{playing=false; time=0; buttons[0].change("Play");}break;
    case 1: update1(true); break;
    case 2: createCells(getGridSizeX(),getGridSizeY()); playing=false; time=0; buttons[0].change("Play"); break;
    case 3: if(!wrap){wrap=true;buttons[3].change("Wrapping is on");}else{wrap=false;buttons[3].change("Wrapping is off");}break;
    case 4: speed=4; buttons[4].change("Speed: 1/"+speed); break;
    case 5: speed-=1; if(speed<1){speed=1;} buttons[4].change("Speed: 1/"+speed); break;
    case 6: speed+=1; if(speed>999){speed=999;} buttons[4].change("Speed: 1/"+speed); break;
    
    default:
      if(buttons[buttonClicked].isSelected()){
        buttons[buttonClicked].changeColor(color(0));
        buttons[buttonClicked].setSelected(false);
        if(buttonClicked<16){
          survival[buttonClicked-7]=false;
        }else{
          born[buttonClicked-16]=false;
        }
      }else{
        buttons[buttonClicked].changeColor(color(0,0,255));
        buttons[buttonClicked].setSelected(true);
        if(buttonClicked<16){
          survival[buttonClicked-7]=true;
        }else{
          born[buttonClicked-16]=true;
        }
      }
  }
  
  mousePressedPrev=mousePressed;
}

cell getGridEntry(int x, int y){
  return grid[x][y];
}
int getBoxSize() {
  return boxSize;
}
int getBorderSize(){
  return borderSize;
}
int getGridSizeX(){
  return grid.length;
}
int getGridSizeY(){
  return grid[0].length;
}
boolean getWrap() {
  return wrap;
}
Boolean getSurvival(int i){
  return survival[i];
}
Boolean getBorn(int i){
  return born[i];
}

class cell {
  int x;
  int y;
  float age;
  boolean toAlive;
  boolean alive;
  Boolean pressedPrev;
  Boolean pressedCurrent;
  cell(int xPos, int yPos) {
    x = xPos;
    y = yPos;
    alive = false;
    toAlive=false;
    age=0;
    pressedPrev=false;
    pressedCurrent=false;
  }
  int aliveNeighbors(){
    int returnValue = 0;
    int maxValueX=getGridSizeX()-1;
    int maxValueY=getGridSizeY()-1;
    boolean wrapBoard=getWrap();
    for(int xOffset = -1; xOffset <= 1; xOffset++){
      for(int yOffset = -1; yOffset <= 1; yOffset++){
        if(!(xOffset==0&&yOffset==0)){
          int toCheckX = x + xOffset;
          int toCheckY = y + yOffset;
          if(toCheckX>maxValueX){if(wrapBoard){toCheckX=0;}else{continue;}}
          if(toCheckY>maxValueY){if(wrapBoard){toCheckY=0;}else{continue;}}
          if(toCheckX<0){if(wrapBoard){toCheckX=maxValueX;}else{continue;}}
          if(toCheckY<0){if(wrapBoard){toCheckY=maxValueY;}else{continue;}}
          returnValue += (getGridEntry(toCheckX, toCheckY).alive) ? 1 : 0;
        }
      }
    }
    return returnValue;
  }
  void drawCell(){
    int cellSize = getBoxSize();
    int padding = getBorderSize();
    stroke(100);
    colorMode(HSB, 100);
    fill(age,100,(alive)?100:0);
    colorMode(RGB, 255);
    rect(x*cellSize+(x+1)*padding,y*cellSize+(y+1)*padding, cellSize, cellSize);
  }
  public void pressed() {
    if(!pressedPrev){
      toAlive = (alive) ? false : true;
    }
    pressedPrev=true;
    pressedCurrent=true;
  }
  public void update() {
    int numAliveNeighbors=aliveNeighbors();
    Boolean stillAlive=false;
    if(alive){
      stillAlive=true;
      //this was a triumph...
      stillAlive=getSurvival(numAliveNeighbors);
    }else{
      stillAlive=getBorn(numAliveNeighbors);
      age=0;
    }
    toAlive=stillAlive;
    if(!stillAlive){
      age=0;
    }
    if(alive){age=min(age+.5,100);}
    //if(alive){age=(age+.5)%100;}
    //if(alive){age=(age+.5);if(age>100){age=0;toAlive=false;}}
  }
  public void update2() {
    alive=toAlive;
    if(!pressedCurrent){
      pressedPrev=false;
    }else{
      pressedCurrent=false;
    }
    drawCell();
  }
}
class button {
  int x;
  int y;
  int buttonWidth;
  int buttonHeight;
  String buttonText;
  float buttonCenterX;
  float buttonCenterY;
  color buttonColor;
  Boolean selected;
  button(int xPos, int yPos, int bWidth, int bHeight, String bText){
    x=xPos;
    y=yPos;
    buttonWidth=bWidth;
    buttonHeight=bHeight;
    buttonText=bText;
    buttonCenterX=x+buttonWidth/2;
    buttonCenterY=y+buttonHeight/2;
    buttonColor=color(0);
    selected=false;
  }
  public Boolean update(Boolean click){
    fill(buttonColor);
    rect(x,y,buttonWidth,buttonHeight);
    fill(255);
    textAlign(CENTER, CENTER);
    text(buttonText,buttonCenterX,buttonCenterY);
    if(click&&mouseX>x&&mouseX<x+buttonWidth&&mouseY>y&&mouseY<y+buttonHeight){
      return true;
    }else{
      return false;
    }
  }
  public void change(String newText){
    buttonText=newText;
  }
  public Boolean isSelected(){
    return selected;
  }
  public void setSelected(Boolean newSelected){
    selected=newSelected;
  }
  public void changeColor(color newColor){
    buttonColor=newColor;
  }
}
